# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""
from pip._vendor.colorama.win32 import CONSOLE_SCREEN_BUFFER_INFO

"""Metody ogólnie dostępne"""
#Marcin Śliwa
from shutil import copyfile,rmtree
import os
import io
from Mapa_PU.kontroler import komunikaty

def kopiuj(zrodlo,cel):
    """Kopiuje plik
    :param zrodlo:zrodlo 
    :param cel: dzie skopiowac
    """
    try:
         
        copyfile(zrodlo,cel)
    except Exception as e:
        komunikaty.blad_systemowy(e)

def czyJestPlik(sciezka):
    """Sprawdza czy w sciezce jest plik
    :param sciezka:ścieżka do pliku
    :return wynik kontroli
    """
    try:
        return os.path.exists(sciezka)
    except Exception as e:
        komunikaty.blad_systemowy(e)
        
def czyJestKatalog(sciezka):
    """Sprawdza czy w sciezce jest plik/katalog
    :param sciezka: ścieżka
    :return wynik kontroli
    """
    try:
        return os.path.isdir(sciezka)
    except Exception as e:
        komunikaty.blad_systemowy(e)
        

def otworzPlik(sciezka,tryb=''):
    #Michal
    """returns text stream (io.TextIOWrapper)
    :param sciezka: sciezka do pliku
    :param tryb: tryb otwarcia
    :return plik
    """
    try:
        if sciezka:
            # Normalizacja sciezki.
            _norm_sciezka = os.path.normpath(sciezka)
            _base_directory = os.path.dirname(_norm_sciezka)
            if os.path.exists(_base_directory):
                return io.open(_norm_sciezka, mode=tryb)
    except Exception as e:
         komunikaty.blad_systemowy(e)
        
def zapiszText(sciezka,text_do_zapisu):
    """zapis do pliku tekstowego
    :param sciezka: ścieżka do pliku
    :param text_do_zapisu: tekst do zapisu
    """
    try:
        if sciezka and text_do_zapisu:
            with otworzPlik(sciezka,tryb='w') as plik:
                plik.write(text_do_zapisu)
    
    except Exception as e:
        komunikaty.blad_systemowy(e)
        
def usun(sciezka):
        """usówa zawartośc istniejącego projektu
        :param sciezka:ścieżka do pliku
        """
        rmtree(sciezka)
        
    